var mx_port_sel = 0;
var mx_scene_sel = 0;
var mx_last_time = 0;

function mx_get_scene(id)
{
	if(id == 0)
		$.getJSON('get_json_scene.php?id=' + id, mx_update);
	else
		$.getJSON('get_json_scene.php?id=' + id, update_cavas);
}

function update_cavas(data)
{
	var cvs = $("#canvas");
	cvs.clearCanvas();
	if(data.length < mx_port)
		return;
	
	var i;
	var height = cvs.attr("height").replace("px", "");
	var width = cvs.attr("width").replace("px", "");

	var d = 0;
	if(mx_port <= 20)
		d = 10;
	else if(mx_port <= 40)
		d = 6;
	else if(mx_port <= 80)
		d = 4;
	else if(mx_port <= 160)
		d = 2;
	else
		return;
	
	var h = height/mx_port;
	var xs = 20+d/2;
	var ys = h/2-d/2;
	var map = data;
	ys = ys > d/2 ? ys : d/2;
	
	for(i=0;i<mx_port;i++)
	{
		cvs.drawArc({
			x: xs, y: h*i+ys,
			fillStyle: '#aaaaaa',
			radius: d
		});
		cvs.drawArc({
			x: width-xs, y: h*i+ys,
			fillStyle: '#aaaaaa',
			radius: d
		});
		if(map[i]>=0 && map[i]<mx_port)
		{
			cvs.drawLine({
				x1: width-xs-20, y1: h*i+ys,
				x2: 20+xs, y2: h*map[i]+ys,
				strokeStyle: '#aaaaaa',
				strokeWidth: 1
			});
		}
	}
}

var last_map = [];
var last_sel = -1;

function mx_update(data)
{
	mx_map = data;
	mx_last_time = (new Date()).getTime();
}

function get_cur_scene()
{
	if((new Date()).getTime() - mx_last_time < 2000)
		return;
	mx_get_scene(0);
}

$(document).ready(function()
{
	var i;
	
	$('#sw_tab_save > *').click(function()
	{
		//$('#sw_tab_save > *').attr('class', 'btn btn-default');
		var btn_s = $('#sw_tab_save > *');
		for(i=0;i<btn_s.length;i++)
			if(btn_s[i].className != 'btn btn-default')
				btn_s[i].className = 'btn btn-default';
		$(this).attr('class', 'btn btn-success');
		mx_scene_sel = $(this).index() + 1;
		mx_get_scene(mx_scene_sel);
	});
	
	$('#btn_load').bind("click", function()
	{
		mx_cmd('load', mx_scene_sel);
		setTimeout(function(){
			mx_get_scene(0);
		}, 500);
		save_splice(mx_scene_sel,"load");
	});
	
	$('#btn_save').bind("click", function()
	{
		mx_cmd('save', mx_scene_sel);
		setTimeout(function(){
			mx_get_scene(mx_scene_sel);
		}, 500);


		save_splice(mx_scene_sel,"save");

	});
	
	setTimeout(get_cur_scene, 500);
	setInterval(get_cur_scene, 2000);
	setInterval(auto_height, 2000);
});

function auto_height()
{
	parent.postMessage(document.body.scrollHeight, "*");
}

$(window).bind("resize", function(){
	auto_height();
});

$(window).bind("load", function(){
	setTimeout(auto_height, 500);
});

function save_splice(mx_scene_sel,save){
	var xmlhttp;
	if (window.XMLHttpRequest)
	{
		//  IE7+, Firefox, Chrome, Opera, Safari ִд
		xmlhttp=new XMLHttpRequest();
	}
	else
	{
		// IE6, IE5 ִд
		xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
	}
	xmlhttp.onreadystatechange=function()
	{
		if (xmlhttp.readyState==4 && xmlhttp.status==200)
		{
			
		}
	}
	xmlhttp.open("GET","../update_json_splice.php?action="+save+"&mx_scene_sel="+mx_scene_sel,true);
	xmlhttp.send();
}
