var mx_port_sel = 0;
var mx_scene_sel = 0;
var mx_last_time = 0;

function mx_get_scene(id)
{
	if(id == 0)
		$.getJSON('get_json_scene.php?id=' + id, mx_update);
	else
		$.getJSON('get_json_scene.php?id=' + id, update_cavas);
}

function update_cavas(data)
{
	var cvs = $("#canvas");
	cvs.clearCanvas();
	if(data.length < mx_port)
		return;
	
	var i;
	var height = cvs.attr("height").replace("px", "");
	var width = cvs.attr("width").replace("px", "");

	var d = 0;
	if(mx_port <= 20)
		d = 10;
	else if(mx_port <= 40)
		d = 6;
	else if(mx_port <= 80)
		d = 4;
	else if(mx_port <= 160)
		d = 2;
	else
		return;
	
	var h = height/mx_port;
	var xs = 20+d/2;
	var ys = h/2-d/2;
	var map = data;
	ys = ys > d/2 ? ys : d/2;
	
	for(i=0;i<mx_port;i++)
	{
		cvs.drawArc({
			x: xs, y: h*i+ys,
			fillStyle: '#aaaaaa',
			radius: d
		});
		cvs.drawArc({
			x: width-xs, y: h*i+ys,
			fillStyle: '#aaaaaa',
			radius: d
		});
		if(map[i]>=0 && map[i]<mx_port)
		{
			cvs.drawLine({
				x1: width-xs-20, y1: h*i+ys,
				x2: 20+xs, y2: h*map[i]+ys,
				strokeStyle: '#aaaaaa',
				strokeWidth: 1
			});
		}
	}
}

var last_map = [];
var last_sel = -1;
function update_port_sel()
{
	if(last_map == mx_map && last_sel == mx_port_sel)
		return;
	last_map = mx_map;
	last_sel = mx_port_sel;
	
	var i;
	var btn_o = $('#sw_tab_o > *');
	for(i=0;i<btn_o.length && i<last_map.length;i++)
	{
		if(last_map[i] == last_sel)
		{
			if(btn_o[i].className != 'btn btn-success')
				btn_o[i].className = 'btn btn-success';
		}
		else
		{
			if(btn_o[i].className != 'btn btn-default')
				btn_o[i].className = 'btn btn-default';
		}
	}

	var splice_chlid = $('.splice_chlid');
	for (var v = 0; v < last_map.length; v++) {
		for (var s = 0; s < splice_chlid.length; s++) {
			var value=splice_chlid[s].getAttribute('value');
			if (last_map[v] == last_sel) {
				if ((value-1)==v) {
					splice_chlid[s].style.background="green";
				}
			}else{
					if ((value-1)==v) {
					splice_chlid[s].style.background="gray";
				}
			}
		}
	}
}

function mx_update(data)
{
	mx_map = data;
	update_port_sel();
	mx_last_time = (new Date()).getTime();
}

function get_cur_scene()
{
	if((new Date()).getTime() - mx_last_time < 2000)
		return;
	mx_get_scene(0);
}

$(document).ready(function()
{
	var i;
	$('#sw_tab_i > *').click(function()
	{
		//$('#sw_tab_i > *').attr('class', 'btn btn-default');
		var btn_i = $('#sw_tab_i > *');
		for(i=0;i<btn_i.length;i++)
			if(btn_i[i].className != 'btn btn-default')
				btn_i[i].className = 'btn btn-default';
		$(this).attr('class', 'btn btn-primary');
		mx_port_sel = $(this).index();
		update_port_sel();
	});
	
	if(login)
	{
		$('#sw_tab_o > *').click(function()
		{
			mx_cmd('o2ox', mx_port_sel, $(this).index());
		});
	
		$('#sw_tab_act > *').click(function()
		{
			if($(this).attr('id'))
				mx_cmd($(this).attr('id'), mx_port_sel);
		});
	}
		
	$('#sw_tab_save > *').click(function()
	{
		//$('#sw_tab_save > *').attr('class', 'btn btn-default');
		var btn_s = $('#sw_tab_save > *');
		for(i=0;i<btn_s.length;i++)
			if(btn_s[i].className != 'btn btn-default')
				btn_s[i].className = 'btn btn-default';
		$(this).attr('class', 'btn btn-success');
		mx_scene_sel = $(this).index() + 1;
		mx_get_scene(mx_scene_sel);
	});
	
	$('#sw_tab_act > *').click(function()
	{
		if($(this).attr('id'))
			mx_cmd($(this).attr('id'), mx_port_sel);
	});
	
	$('#btn_load').bind("click", function()
	{
		mx_cmd('load', mx_scene_sel);
		setTimeout(function(){
			mx_get_scene(0);
		}, 500);
		
	});
	
	$('#btn_save').bind("click", function()
	{
		mx_cmd('save', mx_scene_sel);
		setTimeout(function(){
			mx_get_scene(mx_scene_sel);
		}, 500);
	});
	
	$('#btn_run').bind("click", function()
	{
		mx_stop = 0;
		eval($('#code').val());
	});

	$('#btn_stop').bind("click", function()
	{
		mx_stop = 1;
	});
	
	$('#sw_tab_i > *')[0].className = 'btn btn-primary';
	setTimeout(get_cur_scene, 500);
	setInterval(get_cur_scene, 2000);
	setInterval(auto_height, 2000);
});

function auto_height()
{
	parent.postMessage(document.body.scrollHeight, "*");
}

$(window).bind("resize", function(){
	auto_height();
});

$(window).bind("load", function(){
	setTimeout(auto_height, 500);
});


$('#seting_box').bind("click", function()
{	
	var value=this.getAttribute("value");
	var div=document.getElementById("output_seting");
	if (value==1) {
		//ֵ1͸ԼıͼƬvalueֵ
		this.setAttribute('class',"seting_box_hide");
		this.setAttribute("value",2);
		//Ԫصclass
		div.setAttribute("class","output_seting_box_show");
	}else if(value==2){
		this.setAttribute('class',"seting_box_show");
		this.setAttribute("value",1);
		div.setAttribute("class","output_seting_box_hide");
	}
});

$('#output_seting').bind("click", function(event)
{	
    event.stopPropagation();
});